const sales = require('../model/sale');

class DeliveryController {
  /**
   * @returns versão do monitoramento
   */
  varsao() {
    return '0.0.1';
  }

  async getAssistantDeliveryList() {
    const vndsDelivery = await this.getSalesDelivery();
    return vndsDelivery;
  }

  /**
   * @returns Lista as Vendas Delivery com erros
   */
  async getSalesDelivery() {
    const vendas = [];
    const { rows } = await sales.getDelivery();

    if (rows.length === 0) {
      const filial = await sales.getFilial();
      filial.rows.forEach((element) => {
        vendas.push({
          id: element[0],
          delivery: true,
        });
      });
    } else {
      rows.forEach((element) => {
        let deliverys = true;
        let mensagem = 'Não existem erros para este pedido.';
        /**
         * Aqui é o delivery
         * o IDSINC no element[6] precisa ser S
         * Se for N e A data do element[1] não pode ser menor que 1 minutos de agora e o campo
         * DTHRABERMESA da tabela VENDAREST
         */
        if (element[6] === 'N') {
          const strData = element[2];
          if (strData.getTime() + 6000 < new Date()) {
            deliverys = false;
            mensagem = 'O pedido não foi enviado para a loja.';
          } else {
            deliverys = true;
          }
        }

        /** Só tem push as vendas com problemas
         * Descomentar o IF para produção
        */
        const options = { year: 'numeric', month: '2-digit', day: '2-digit' };
        vendas.push({
          id: element[0],
          loja: element[5],
          venda: element[3],
          data: element[2].toLocaleDateString('pt-BR', options).split('-').reverse().join('/'),
          delivery: deliverys,
          message: mensagem,
        });
      });
    }
    return vendas;
  }
}

module.exports = new DeliveryController();
