const OracleService = require('../service/OracleService');

class adqUltMovExtModel {
  constructor() {
    this.GET_ADQULTMOVEXT = `
            SELECT
               C.CDCLIENTE,
               C.CDCONSUMIDOR,
               C.CDFAMILISALD,
               F.DTMOVEXTCONS,
               NVL(F.VRSALDCONEXT,0) AS VRSALDCONEXT
            FROM
               (SELECT
             C.CDCLIENTE,
             C.CDCONSUMIDOR,
             F.CDFAMILISALD
                FROM
             CONSUMIDOR C,
             FAMILIASALDO F
                WHERE
               ((CDCLIENTE    = :P_CDCLIENTE)    OR (:P_TCDCLIENTE = 'T')) AND
               ((CDCONSUMIDOR = :P_CDCONSUMIDOR) OR (:P_TCDCONS    = 'T'))
               ) C,
               (SELECT
             E.CDCLIENTE,
             E.CDCONSUMIDOR,
             E.CDFAMILISALD,
             E.DTMOVEXTCONS,
             E.VRSALDCONEXT
                FROM
             EXTRATOCONS E,
             (SELECT
                 E.CDCLIENTE,
                 E.CDCONSUMIDOR,
                 E.CDFAMILISALD,
                 D.DTMOVEXTCONS,
                 MAX(E.NRSEQMOVEXT) AS NRSEQMOVEXT
              FROM
                 EXTRATOCONS E,
                 (SELECT
               CDCLIENTE,
               CDCONSUMIDOR,
               CDFAMILISALD,
               MAX(DTMOVEXTCONS) AS DTMOVEXTCONS
            FROM
               EXTRATOCONS
            WHERE
                ((CDCLIENTE    = :P_CDCLIENTE)    OR (:P_TCDCLIENTE = 'T')) AND
                ((CDCONSUMIDOR = :P_CDCONSUMIDOR) OR (:P_TCDCONS    = 'T')) AND
              (DTMOVEXTCONS < TIMESTAMP :P_DTMOVEXTCONS)
            GROUP BY
               CDCLIENTE,
               CDCONSUMIDOR,
               CDFAMILISALD
                 ) D
              WHERE
                 (E.CDCLIENTE    = D.CDCLIENTE)    AND
                 (E.CDCONSUMIDOR = D.CDCONSUMIDOR) AND
                 (E.CDFAMILISALD = D.CDFAMILISALD) AND
                 (E.DTMOVEXTCONS = D.DTMOVEXTCONS)
              GROUP BY
                 E.CDCLIENTE,
                 E.CDCONSUMIDOR,
                 E.CDFAMILISALD,
                 D.DTMOVEXTCONS
             ) DT
                WHERE
             (E.CDCLIENTE     = DT.CDCLIENTE)    AND
             (E.CDCONSUMIDOR  = DT.CDCONSUMIDOR) AND
             (E.CDFAMILISALD  = DT.CDFAMILISALD) AND
             (E.DTMOVEXTCONS  = DT.DTMOVEXTCONS) AND
             (E.NRSEQMOVEXT   = DT.NRSEQMOVEXT)
               ) F
            WHERE
               (C.CDCLIENTE    = F.CDCLIENTE    (+)) AND
               (C.CDCONSUMIDOR = F.CDCONSUMIDOR (+)) AND
               (C.CDFAMILISALD = F.CDFAMILISALD (+))
            ORDER BY
               C.CDCLIENTE,
               C.CDCONSUMIDOR,
               C.CDFAMILISALD
        `;
  }
  get(params) {
    return OracleService.connect().then((sql) => {
      return OracleService.execute(this.GET_ADQULTMOVEXT, params);
    });
  }
}

module.exports = new adqUltMovExtModel();
