const OracleService = require('../service/OracleService');

class saleModel {
  constructor() {
    /** São mais de uma loja por filial */

    /**
     * O pedido delivery tem o prefixo "DLV_" no campo DSCOMANDA.
     * Daniel Rosa disse para subistituir o
     * INNER JOIN VENDAREST VR ON VR.NRVENDAREST = V.NRCOMANDAVND
     * Para
     * INNER JOIN VENDAREST VR ON VR.NRVENDARESTAUX = V.NRVENDAREST
     */
    this.GET_SALES_DELIVERY = `
    SELECT C.CDFILIAL AS id, C.DSCOMANDA, V.DTHRABERMESA, C.NRCOMANDA,
           C.CDLOJA, L.NMLOJA, V.IDSINCMSDE
      FROM COMANDAVEN C
      JOIN VENDAREST V
        ON C.CDFILIAL = V.CDFILIAL
       AND C.NRVENDAREST = V.NRVENDAREST
      JOIN LOJA L
        ON C.CDFILIAL = L.CDFILIAL
       AND C.CDLOJA = L.CDLOJA
     WHERE C.DSCOMANDA LIKE 'DLV%'
       AND V.DTHRABERMESA >= (SYSDATE - INTERVAL '24' HOUR)
     ORDER BY DTHRABERMESA DESC
    `;

    this.GET_FILIAL = `
      SELECT CDFILIAL AS id FROM COMANDAVEN WHERE ROWNUM = 1
    `;


    // AND  V.DTVENDA LIKE '%09/20'
    /** Mesa e comanda
    * Os campos que indicam que o pedido esta pendente são: IDSINCMSDE = 'N', NRVENDARESTAUX = NULL
    */
    this.GET_SALES_MC = `
      SELECT CDFILIAL AS id, NRVENDAREST, IDSINCMSDE, NRVENDARESTAUX FROM VENDAREST
    `;

    this.GET_SALES_ALL = `
      SELECT CDFILIAL AS id, VENDA.*
      FROM VENDA
      WHERE IDIMPVENDA <> 'S'
      AND ROWNUM >= :MIN_ROW;
    `;
    // AND DTVENDA LIKE '%09/20'
    /** Qualquer venda que não subiu
     * SELCT * FROM VENDA WHERE IDIMPVENDA <> 'S'
     */
  }

  getDelivery() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_DELIVERY);
    });
  }

  getMC() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_MC);
    });
  }

  getAll(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_ALL, params);
    });
  }

  getFilial() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_FILIAL);
    });
  }
}

module.exports = new saleModel();
