const OracleService = require('../service/OracleService');

class watchModel {
  constructor() {
    this.GET_COMPONENT = `
      SELECT * FROM PORTAL
      WHERE NOME = :NOME
    `;

    this.ADD_COMPONENT = `
      INSERT INTO PORTAL
      (NOME, COMPONENT, CONEXAO)
      VALUES (:NOME, :COMPONENT, :CONEXAO)
    `;

    this.UP_COMPONENT = `
      UPDATE PORTAL SET STATUS = :STATUS, ORDEM = :ORDEM, COMPONENT = :COMPONENT, ITEM = :ITEM WHERE ID = :ID
    `;

    this.GET_NAV = `
      SELECT ITEM FROM PORTAL WHERE STATUS = 1 AND NAVEGACAO = 'monitoring' ORDER BY ORDEM ASC
    `;

    this.GET_CONEXAO = `
      SELECT CONEXAO FROM PORTAL
      WHERE NAVEGACAO = :NAVEGACAO
    `;
  }

  getAll(parans) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_COMPONENT, parans);
    })
  }

  addComponent(parans) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.ADD_COMPONENT, parans);
    });
  }

  upElemnet(parans) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.UP_COMPONENT, parans);
    });
  }

  getNav() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_NAV);
    });
  }

  getConexao(parans) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_CONEXAO, parans);
    });
  }
}

module.exports = new watchModel();
