import { SocketEvent } from '@/socket/socket-event';
import {
  Config,
  Http,
  IDictionary,
  IEventParam,
  Loader,
} from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { io, Socket } from 'socket.io-client';
import {
  AlertService,
  Modal,
} from '@zeedhi/common';
import Router from '../router';

export class WatchController {
  public socket?: Socket;

  /** Style Status do Sat */
  public getConditionalStyle() {
    // console.warn(row);
    // let af:any = false;
    // if (row.codigo === '9999') {
    //   Object.entries(row).forEach(([key, value]) => {
    //     // console.warn(key + value); // "a 5", "b 7", "c 9"
    //     af = value;
    //     // console.warn(value);
    //     return value;
    //   });
    //   console.warn(af);
    // }
    // if (
    //   af === 'Ativo'
    //   || af === 'true'
    // ) {
    //   return 'green';
    // }
    // return 'red';
    // if (row.situacao === 'Ativo') {
    //   return 'green';
    // }
    // return 'red';
  }

  public getConditionalColumnStyle({ column, row }: IDictionary<any>) {
    let cor;
    const situacao = 'situacao';

    [row].forEach((element:any) => {
      if (column.name === 'websocket') {
        cor = (element[situacao] === 'Ativo') ? 'green' : 'red';
      } else {
        cor = 'red';
        if (element[situacao] === 'Ativo') {
          cor = this.switchColor(element[column.name]);
        }
      }
    });
    return cor;
  }

  /** Menssagem Status do Sat */
  public getConditionalMessage({ row }: IDictionary<any>) {
    if (
      (row.sat === '') && (row.socketId !== '')
    ) {
      return 'Erro ao tentar uma comunicação com o SAT.';
    }
    return row.mensagem;
  }

  public startModal() {
    Loader.getInstance('SatController').createFullscreenModal();
    Loader.getInstance('SalesController').createFullscreenModal();
    Loader.getInstance('DeliveryController').createFullscreenModal();
    Loader.getInstance('ParametersController').createFullscreenModal();
    Loader.getInstance('SefazController').createFullscreenModal();
  }

  private title = Router.currentRoute.params.name.toUpperCase();

  private fullscreenModal!: Modal;

  private conexao: any;

  public async createFullscreenModal() {
    // const watchModalName:any = router.currentRoute.query.monitoring;
    // this.fullscreenModal = await ModalService.createFromJson(watchModalName, true);
  }

  /**
   * Método executado quando o grid é criado
   */
  public gridMounted({ component }: IEventParam<TekGrid>) {
    // inicializa o socket
    // console.warn(Router.currentRoute.params.name);
    // console.warn('Controller do Watch');
    // const router = new Router();
    // const watchModalName:any = router.currentRoute.query.monitoring;
    // this.fullscreenModal = await ModalService.createFromJson(watchModalName, true);
    // Duplicidade n cupom
    if (Router.currentRoute.params.name === 'watch') {
      Router.push('watch/monitoring');
    }
    const rq = 'connect?obj=';
    const conexao = Config.metadataEndPoint + rq + Router.currentRoute.params.name;
    const ioOpt = {};

    const req = Http.get(conexao);
    component.datasource.loading = true;
    req.then((response) => {
      // console.warn(conexao, response);
      this.conexao = response.data.conexao;
      response.data.conexao.forEach((element:any) => {
        this.socket = io(Config.endPoint, ioOpt);
        /** Emit */
        this.socket.off(SocketEvent.CONNECTION)
          .emit(element.route, element.args);

        /** Esculta */
        this.socket.off(SocketEvent.CONNECTION)
          .on(element.route, async (branc: IDictionary) => {
            /** Reconnexão, Desconectado */
            if (branc.text === 'UNIDADE CONECTADA') {
              /** Reconectou */
              component.datasource.get().then((r: IDictionary) => {
                if (r.length !== 0) {
                  branc.message.data.forEach((elements:any) => {
                    component.datasource.put(elements);
                  });
                } else {
                  component.datasource.updateData(branc.message.data);
                  component.datasource.loading = false;
                }
              });
            } else if (branc.text === 'UNIDADE DESCONECTADA') {
              /** Disconectou */
              component.datasource.put(branc.message.data[4]);
              component.datasource.loading = false;
            }

            component.datasource.get().then((r: IDictionary) => {
              if (r.length === 0) {
                if (Router.currentRoute.params.name !== 'login'
                && element.route !== 'login'
                && Object.keys(branc.message.data[0]).length > 2) {
                  component.datasource.updateData(branc.message.data);
                  component.datasource.loading = false;
                } else if (element.route === 'login'
                  && Router.currentRoute.params.name === 'monitoring') {
                    component.datasource.updateData(branc.message);
                    component.datasource.loading = false;
                }
              } else if (
                branc.message.data.length > 0
              ) {
                if (
                  Object.prototype.toString.call(branc.message.data) === '[object Array]'
                  && branc.message.data.length > 1
                ) {
                  /** Sefaz - Diferenciado */
                  if (branc.message.data[0].idnormal !== undefined) {
                    /** Sefaz tem um modelo diferente de trabalhar as cores
                     * São 3 colunas para conferir
                    */
                    if (element.route === 'sefaz') {
                      const coponetAtual = r.filter((v: IDictionary) => {
                        branc.message.data.forEach((elements:any) => {
                          if (elements.id === v.id) {
                            elements.sefaz = this.seFazStatus(elements);
                            Object.assign(v, elements);
                            return v;
                          }
                          return false;
                        });
                        return v;
                      });
                      if (coponetAtual[0] !== undefined) {
                        component.datasource.put(coponetAtual[0]);
                      }
                    }
                  }
                } else if (branc.message.data.length > 0) {
                  const coponetAtual = r.filter((v: IDictionary) => {
                    branc.message.data.forEach((elements:any) => {
                      if (elements.id === v.id) {
                        Object.assign(v, elements);
                        return v;
                      }
                      return false;
                    });
                    return v;
                  });
                  if (coponetAtual[0] !== undefined) {
                    component.datasource.put(coponetAtual[0]);
                  }
                  component.datasource.loading = false;
                }
              } else {
                component.datasource.loading = false;
                // console.warn(branc);
                // component.datasource.updateData([{ delivery: true }]);
              }
            });
          });
      });
    }).catch(() => {
      component.datasource.loading = false;
    });

    this.createFullscreenModal();
    this.socket = io(Config.endPoint);
    this.socket.on('disconnect', () => {
      AlertService.show({
        name: 'buttons-alert',
        text: 'A página será recarregada para restabelecer a conexão.',
        color: 'error',
        right: true,
        top: true,
        value: false,
        buttonsSlot: [
          {
            name: 'undo-button',
            component: 'ZdButton',
            icon: true,
            iconName: 'close',
            color: 'white',
            events: {
              click: () => { AlertService.hide(); },
            },
          },
        ],
      });

      setTimeout(() => {
        document.location.reload();
      }, 5000);
    });
  }

  public seFazStatus(element:any): boolean {
    let cor = true;
    if (
      element.idnormal === 'CINZA'
      && element.idscan === 'CINZA'
      && element.idsvc === 'CINZA'
    ) {
      cor = true;
    } else {
      cor = false;
    }
    return cor;
  }

  public push(monitor:any) {
    Router.push(`/watch/${monitor.column.name}`);
  }

  /**
   * Método executado logo antes do grid ser destruído
   */
  public gridBeforeDestroy() {

  }

  /** Status do Normal */
  public getConditionalStyleNormal({ row }: IDictionary<any>) {
    if (row.idnormal === 'CINZA') {
      return 'Gray';
    }
    return 'green';
  }

  /** Status do Normal */
  public getConditionalNormal({ row }: IDictionary<any>) {
    let message = '';
    if (row.idnormal === 'CINZA') {
      message = 'falta Serviço ou falha de conexão.';
    } else if (row.idnormal === 'VERDE') {
      message = 'Sistema operante.';
    } else {
      message = row.message;
    }
    return message;
  }

  /** Status do Vendas */
  public getConditionalStyleScan({ row }: IDictionary<any>) {
    if (row.idscan === 'CINZA') {
      return 'green';
    }
    return 'red';
  }

  public getConditionalScan({ row }: IDictionary<any>) {
    if (row.idscan === 'CINZA') {
      return 'green';
    }
    return 'red';
  }

  /** Status do Vendas */
  public getConditionalStyleSvc({ row }: IDictionary<any>) {
    if (row.idsvc === 'CINZA') {
      return 'green';
    }
    return 'red';
  }

  public getConditionalSvc({ row }: IDictionary<any>) {
    if (row.idsvc === 'CINZA') {
      return 'green';
    }
    return 'red';
  }

  public switchColor(color:any) {
    return (color === true || color === 'Ativado') ? 'green' : 'red';
  }
}
